ruby_types = [integer:1, float: 2.5, array: [3, 5, 7], object: {name: "castle", breed: "borzoi"}]
# .methods on an object gives you a list of methods
# an integer can be turned into a string with .to_s
# you can chain methods ex.(123.to_s.reverse.to_i - 321)
# blocks can be used on array methods and hashes
# map transforms, each applys a function to puts

movies = ["lost highway", "twin peaks", "blue velvet"]

movies.each do |movie|
  puts movie.upcase
end

movies.map { |movie| movie.upcase }

3.times { puts "hello" }
#hello
#hello
#hello

5.upto(10) { |n| puts n }
#5 6 7 8 9 10
#=============================================

def three?(n)
  n == 3
end

puts three?(3)
puts three?(10)

def gt_five(n)
  n > 5
end

puts gt_five(10)
puts gt_five(2)

def mi_to_km(n)
  n * 1.6
end

puts mi_to_km(3)
puts mi_to_km(10)

def max(n, x)
  n > x ? n : x
end

puts max(3, 10)
puts max(40, 100)


def show_triangle(n)
  1.upto(n) { |length| puts "#" * length }
end

show_triangle(10)

def fizzbuzz(length)
  1.upto(length) do |n|
    if n % 3 == 0 && n % 5 == 0
      puts "FizzBuzz"
    elsif n % 5 == 0
      puts "Buzz"
    elsif n % 3 == 0
      puts "Fizz"
    else
      puts n
    end
  end
end

fizzbuzz(100)

def hello(name)
  puts "Hello there #{name}!"
end

hello('Alli')

#######################################

class Player

  attr_reader :health, :role
  attr_accessor :name

  def initialize(name)
    @name = name.capitalize
    @health = rand(50..100)
    @role = role_names.sample
  end

  def role_names
   [
    "Barbarian",
    "Bard",
    "Cleric",
    "Druid",
    "Fighter",
    "Monk",
    "Paladin",
    "Ranger",
    "Rogue",
    "Sorcerer",
    "Wizard",
  ]
  end
end

player = Player.new("DragonBitch")
puts player
puts player.name
puts player.health
puts player.role



def sum(nums)
  nums.reduce(0) { |result, n| result + n }
end

puts sum([1, 2, 3, 4])
puts sum([])

##doubles
#nums.map { |n| n * 2}
